import re, sys

speciesName = sys.argv[1]
infile = sys.argv[2]

outfileName = "mart-export-out_" + speciesName + ".txt"


###########
def pickup_tss_geneName(stock):
    #print("########")
    geneID_fn = ""
    strand = ""
    geneName_fn = ""
    tss_fn = ""

    lines = stock.split("\n")
    positions = []
    for line in lines:
        if "	gene	" in line:
            #print(line)
            #NC_000001.11	BestRefSeq	gene	69091	70008	.	+	.	ID=gene-OR4F5;Dbxref=GeneID:79501,HGNC:HGNC:14825;Name=OR4F5;description=olfactory receptor family 4 subfamily F member 5;gbkey=Gene;gene=OR4F5;gene_biotype=protein_coding
            #print("line:", line)
            match = ""
            if re.search("	([^\t]+)	([^\t]+)	\.	([+-])	\..*=GeneID:(\d+)[^\d].*;gene=([^;]+);", line):
                match = re.search("	([^\t]+)	([^\t]+)	\.	([+-])	\..*=GeneID:(\d+)[^\d].*;gene=([^;]+);", line)
            elif re.search("	([^\t]+)	([^\t]+)	\.	([+-])	\..*,GeneID:(\d+)[^\d].*;gene=([^;]+);", line):
                match = re.search("	([^\t]+)	([^\t]+)	\.	([+-])	\..*,GeneID:(\d+)[^\d].*;gene=([^;]+);", line)
            else:
                print("Check =GeneID ,GeneID")
                exit()
            start = match.group(1)
            stop = match.group(2)
            strand = match.group(3)
            geneID_fn = match.group(4)
            geneName_fn = match.group(5)
            positions.append(int(start))
            positions.append(int(stop))
        #elif "	transcript	" in line or "	mRNA	" in line or "	CNS	" in line:
        #    match = re.search("	(\d+)	(\d+)	\.	[+-]	\.", line)
        #    start = match.group(1)
        #    stop = match.group(2)
        #    #print(start, stop)
        #    positions.append(int(start))
        #    positions.append(int(stop))
    #print("geneID_fn", geneID_fn, "strand", strand, "geneName_fn", geneName_fn, "geneName_fn", geneName_fn)
    if positions:
        if strand == "+":
            tss_fn = min(positions)
        else:
            tss_fn = max(positions)
    else:
        tss_fn = str(0)
    return geneID_fn, geneName_fn, tss_fn

################


count = 0
chromosome = ""
flag = 0
stock = ""
recs_list = []
with open(infile) as fileobject:
    for line in fileobject:
        count += 1

        #line = line.rstrip("\n")
        if line.startswith("#"):
            continue
        #if count > 50:
        #    break
        
        
        if re.search(";genome=mitochondrion;", line):
            chromosome = "mitochondrion"
        #elif re.search(";chromosome=[^;]+;", line):
            #match = re.search(";chromosome=([^;]+);", line)
        elif re.search(";product=chromosome ([^ ]+) ", line):
            match = re.search(";product=chromosome ([^ ]+) ", line)
            chromosome = match.group(1)
        elif re.search("	gene	", line) or re.search("	pseudogene	", line):
            if flag == 1:
                if "gene_biotype=protein_coding" in stock:
                    geneID, geneName, tss = pickup_tss_geneName(stock)
                    #print(stock)
                    if not chromosome:
                        chromosome = "NONE"
                    recs_list.append([geneID, geneName, chromosome, tss])
                    #print("tss", tss)
                    #print("\n")
                stock = ""
                stock += line
            elif flag == 0:
                flag = 1
                stock += line
        else:
            stock += line
geneID, geneName, tss = pickup_tss_geneName(stock)
if not chromosome:
    chromosome = "NONE"
recs_list.append([geneID, geneName, chromosome, tss])
recs_list = sorted(recs_list, key = lambda x:(x[2],x[3]))
#recs_list = sorted(recs_list, key = lambda x:(x[2]))

out = open(outfileName, "w")
out.write("GeneID	GeneName	Chromosome	mRNA/transcript start\n")
for rec in recs_list:
    out.write(rec[0] + "\t" + rec[1] + "\t" + rec[2] + "\t" + str(rec[3]) + "\n")
out.close()

out.close()